# mypy-boto3-inspector

[![PyPI - mypy-boto3-inspector](https://img.shields.io/pypi/v/mypy-boto3-inspector.svg?color=blue)](https://pypi.org/project/mypy-boto3-inspector)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-inspector.svg?color=blue)](https://pypi.org/project/mypy-boto3-inspector)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-inspector](#mypy-boto3-inspector)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)

Type annotations for
[boto3.Inspector 1.14.0](https://boto3.amazonaws.com/v1/documentation/api/1.14.0/reference/services/inspector.html#Inspector) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Inspector` service.

```bash
python -m pip install boto3-stubs[inspector]
```

Use `boto3` with `mypy_boto3_inspector` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_inspector import InspectorClient

# Now mypy can check if your code is valid.
client: InspectorClient = boto3.client("inspector")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: InspectorClient = session.client("inspector")



# Annotated paginators are included as well

import mypy_boto3_inspector.paginator as inspector_paginators

list_assessment_run_agents_paginator: inspector_paginators.ListAssessmentRunAgentsPaginator = client.get_paginator("list_assessment_run_agents")
list_assessment_runs_paginator: inspector_paginators.ListAssessmentRunsPaginator = client.get_paginator("list_assessment_runs")
list_assessment_targets_paginator: inspector_paginators.ListAssessmentTargetsPaginator = client.get_paginator("list_assessment_targets")
list_assessment_templates_paginator: inspector_paginators.ListAssessmentTemplatesPaginator = client.get_paginator("list_assessment_templates")
list_event_subscriptions_paginator: inspector_paginators.ListEventSubscriptionsPaginator = client.get_paginator("list_event_subscriptions")
list_exclusions_paginator: inspector_paginators.ListExclusionsPaginator = client.get_paginator("list_exclusions")
list_findings_paginator: inspector_paginators.ListFindingsPaginator = client.get_paginator("list_findings")
list_rules_packages_paginator: inspector_paginators.ListRulesPackagesPaginator = client.get_paginator("list_rules_packages")
preview_agents_paginator: inspector_paginators.PreviewAgentsPaginator = client.get_paginator("preview_agents")
```

## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_inspector` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python
import boto3

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("inspector")

session_client = boto3.Session().client("inspector")
```